/*
 * wxitemsp.h
 * wxCLIPS item classes
 *
 */

#ifndef exitemsph
#define exitemsph


// Button
class wxExtensionButton: public wxButton
{
 public:
  wxExtensionButton(wxPanel *panel, wxFunction func, char *label, int x = -1, int y = -1,
           int width = -1, int height = -1, long style = 0, char *name = "button"):
    wxButton(panel, func, label, x, y, width, height, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxButton));
 }
  wxExtensionButton(wxPanel *panel, wxFunction func, wxBitmap *bitmap, int x = -1, int y = -1,
           int width = -1, int height = -1, long style = 0, char *name = "button"):
   wxButton(panel, func, bitmap, x, y, width, height, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxButton));
 }
 ~wxExtensionButton(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxButton), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// Group box
class wxExtensionGroupBox: public wxGroupBox
{
 public:
  wxExtensionGroupBox(wxPanel *panel, char *label, int x = -1, int y = -1,
           int width = -1, int height = -1, long style = 0, char *name = "groupBox"):
    wxGroupBox(panel, label, x, y, width, height, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxGroupBox));
 }
 ~wxExtensionGroupBox(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxGroupBox), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// Message
class wxExtensionMessage: public wxMessage
{
 public:
  wxExtensionMessage(wxPanel *panel, char *label, int x = -1, int y = -1, long style = 0, char *name = "message"):
    wxMessage(panel, label, x, y, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxMessage));
 }
  wxExtensionMessage(wxPanel *panel, wxBitmap *bitmap, int x = -1, int y = -1, long style = 0, char *name = "message"):
    wxMessage(panel, bitmap, x, y, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxMessage));
 }
 ~wxExtensionMessage(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxMessage), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// Text
class wxExtensionText: public wxText
{
 public:
  wxExtensionText(wxPanel *panel, wxFunction func, char *label, char *value = "",
         int x = -1, int y = -1, int width = -1, int height = -1, long style = 0, char *name = "text"):
    wxText(panel, func, label, value, x, y, width, height, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxText));
 }

 ~wxExtensionText(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxText), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// Multi-line Text
class wxExtensionMultiText: public wxMultiText
{
 public:
  wxExtensionMultiText(wxPanel *panel, wxFunction func, char *label, char *value = "",
         int x = -1, int y = -1, int width = -1, int height = -1, long style = 0, char *name = "multiText"):
    wxMultiText(panel, func, label, value, x, y, width, height, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxMultiText));
 }

 ~wxExtensionMultiText(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxMultiText), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// Check box
class wxExtensionCheckBox: public wxCheckBox
{
 public:
  wxExtensionCheckBox(wxPanel *panel, wxFunction func, char *label,
         int x = -1, int y = -1, int width = -1, int height = -1, long style = 0, char *name = "checkBox"):
    wxCheckBox(panel, func, label, x, y, width, height, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxCheckBox));
 }

 ~wxExtensionCheckBox(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxCheckBox), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// Slider
class wxExtensionSlider: public wxSlider
{
 public:
  wxExtensionSlider(wxPanel *panel, wxFunction func, char *label,
         int value, int min_value, int max_value, int width, int x = -1, int y = -1, long style = 0, char *name = "slider"):
    wxSlider(panel, func, label, value, min_value, max_value, width, x, y, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxSlider));
 }

 ~wxExtensionSlider(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxSlider), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// List box
class wxExtensionListBox: public wxListBox
{
 public:
  wxExtensionListBox(wxPanel *panel, wxFunction func, char *label,
                 Bool multiple = FALSE, int x = -1, int y = -1, int width = -1, int height = -1,
                 int noStrings = 0, char **strings = NULL, long style = 0, char *name = "listBox"):
    wxListBox(panel, func, label, multiple, x, y, width, height, noStrings, strings, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxListBox));
 }

 ~wxExtensionListBox(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxListBox), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// Choice
class wxExtensionChoice: public wxChoice
{
 public:
  wxExtensionChoice(wxPanel *panel, wxFunction func, char *label,
                 int x = -1, int y = -1, int width = -1, int height = -1, int n = 0, char **choices = NULL,
                 long style = 0, char *name = "choice"):
    wxChoice(panel, func, label, x, y, width, height, n, choices, style, name)
 {
   wxStoreThingInTable((long)this, this, CLASSINFO(wxChoice));
 }

 ~wxExtensionChoice(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxChoice), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};

// RadioBox
class wxExtensionRadioBox: public wxRadioBox
{
public:
    wxExtensionRadioBox(wxPanel *panel, wxFunction func, char *label,
                        int x = -1, int y = -1, int width = -1,
                        int height = -1, int n = 0, char **choices = NULL,
                        int majorDim = 0, long style = 0, char *name = "radioBox"):
    wxRadioBox(panel, func, label, x, y, width, height, n, choices,
               majorDim, style, name)
    {
        wxStoreThingInTable((long)this, this, CLASSINFO(wxRadioBox));
    }

    ~wxExtensionRadioBox(void)
    {
        wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxRadioBox),
                                                           "OnDelete");
        if (func)
            (* (void (*)(long)) func) ((long)this);
        wxDeleteThingInTable((long)this);
    }
};


class wxExtensionMenuBar: public wxMenuBar
{
 public:
  wxExtensionMenuBar(void)
  {
    wxStoreThingInTable((long)this, this, CLASSINFO(wxMenuBar));
  }
  ~wxExtensionMenuBar(void)
  {
     wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxMenuBar), "OnDelete");
     if (func)
       (* (void (*)(long)) func) ((long)this);
     wxDeleteThingInTable((long)this);
  }
};

class wxExtensionMenu: public wxMenu
{
 public:
  wxExtensionMenu(char *title, wxFunction func):wxMenu(title, func)
  {
    wxStoreThingInTable((long)this, this, CLASSINFO(wxMenu));
  }
  ~wxExtensionMenu(void)
  {
     wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxMenu), "OnDelete");
     if (func)
       (* (void (*)(long)) func) ((long)this);
     wxDeleteThingInTable((long)this);
  }
};

#if USE_GAUGE
// Gauge
class wxExtensionGauge: public wxGauge
{
 public:
  wxExtensionGauge(wxPanel *panel, char *label, int range, int x = -1, int y = -1,
           int width = -1, int height = -1, long style = 0, char *name = "gauge"):
    wxGauge(panel, label, range, x, y, width, height, style, name)
 {
    wxStoreThingInTable((long)this, this, CLASSINFO(wxGauge));
 }
 ~wxExtensionGauge(void)
 {
   wxExtensionFunction func = wxFindExtensionCallback(CLASSINFO(wxGauge), "OnDelete");
   if (func)
     (* (void (*)(long)) func) ((long)this);
   wxDeleteThingInTable((long)this);
 }
};
#endif

#endif
  // exitemsp.h
  